//
// kilib/file.cpp : File IO
//

#include "stdafx.h"
#include "kilib.h"
namespace kilib {


//-------------------------------------------------------------------------


const uchar* FileR::open( const char* fname )
{
	close();

	// t@CJ
	m_hFile = ::CreateFile( fname, GENERIC_READ, 0, NULL, OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL );
	if( m_hFile == INVALID_HANDLE_VALUE )
		return NULL;
	m_Size = ::GetFileSize( m_hFile, NULL );

	if( m_Size==0 )
	{
		// 0oCg̃t@C̓}bsOoȂ̂œKɉ
		m_pBase = static_cast<const void *>(&m_Size);
	}
	else
	{
		// }bsOIuWFNg
		m_hFMO = ::CreateFileMapping( m_hFile, NULL, PAGE_READONLY, 0, 0, NULL );
		if( m_hFMO == NULL )
		{
			::CloseHandle( m_hFile );
			m_hFile = INVALID_HANDLE_VALUE;
			return NULL;
		}

		// r[
		// i悭lS}bv4GBzt@Cǂ߂ȂȂc(^^;j
		m_pBase = ::MapViewOfFile( m_hFMO, FILE_MAP_READ, 0, 0, 0 );
		if( m_pBase == NULL )
		{
			::CloseHandle( m_hFMO );
			::CloseHandle( m_hFile );
			m_hFile = INVALID_HANDLE_VALUE;
		}
	}

	return static_cast<const uchar*>(m_pBase);
}


void FileR::close()
{
	if( m_hFile != INVALID_HANDLE_VALUE )
	{
		if( m_pBase != static_cast<const void*>(&m_Size) )
			::UnmapViewOfFile( m_pBase );
		if( m_hFMO != NULL )
			::CloseHandle( m_hFMO );
		::CloseHandle( m_hFile );
		m_hFile = INVALID_HANDLE_VALUE;
		m_hFMO  = NULL;
		m_pBase = NULL;
	}
}


ulong FileR::size() const
{
	return m_Size;
}


//-------------------------------------------------------------------------


FileR::FileR()
{
	m_hFile = INVALID_HANDLE_VALUE;
	m_hFMO  = NULL;
	m_pBase = NULL;
}


FileR::~FileR()
{
	close();
}


//-------------------------------------------------------------------------


};     // namespace kilib
