#ifndef _KILIB_KTL_APTR_H
#define _KILIB_KTL_APTR_H
namespace kilib{


//-------------------------------------------------------------------------
//@{
//	|C^
//
//	cȂłĂ̂ȂcB
//	Java͕֗WoB
//@}
//-------------------------------------------------------------------------


template<class T>
class autoptr
{
public:
	//@{
	//	RXgN^B
	//	@param obj L|C^
	//@}
	explicit autoptr( const T* obj=NULL )
	{
		m_pObj   = const_cast<T*>( obj );
		m_fOwner = true;
	}

	//@{
	//	Rs[RXgN^B
	//@}
	autoptr( const autoptr<T>& rhs )
	{
		m_pObj       = rhs.m_pObj;
		m_fOwner     = rhs.m_fOwner;
		rhs.m_fOwner = false;
	}

	//@{
	//	fXgN^B
	//@}
	virtual ~autoptr()
	{
		if( m_fOwner )
		{
			delete m_pObj;
		}
	}

	//@{
	//	VIuWFNgLB܂ł̏LIuWFNg͉
	//@}
	void operator=( const T* obj )
	{
		if( m_fOwner )
		{
			delete m_pObj;
		}
		m_pObj   = const_cast<T*>( obj );
		m_fOwner = true;
	}

	//@{
	//	VIuWFNgLB܂ł̏LIuWFNg͉
	//@}
	void operator=( const autoptr<T>& rhs )
	{
		if( m_fOwner )
		{
			delete m_pObj;
		}
		m_pObj       = rhs.m_pObj;
		m_fOwner     = rhs.m_fOwner;
		rhs.m_fOwner = false;
	}

	//@{
	//	ANZX
	//@}
	T* ptr() const
	{
		return m_pObj;
	}

	//@{
	//	ANZX
	//@}
	T& operator*() const
	{
		return *m_pObj;
	}

	//@{
	//	ANZX
	//@}
	#pragma warning( disable : 4284 )
	T *operator->() const
	{
		return m_pObj;
	}
	#pragma warning( default : 4284 )

protected:
	T*           m_pObj;
	mutable bool m_fOwner;
};



};     // namespace kilib
#endif // _KILIB_APTR_H
